# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorarch: %global perl_vendorarch %(eval "`perl -V:installvendorarch`"; echo $installvendorarch)}

Name:		perl-Digest-SHA
Version:	5.71
Release:	1.%{__distinit}%{__distvers}
Summary:	Perl extension for SHA-1/224/256/384/512
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Digest-SHA/
Source0:	http://search.cpan.org/CPAN/authors/id/M/MS/MSHELOR/Digest-SHA-%{version}.tar.gz
Patch0:		Digest-SHA-5.71-perl-path.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(Getopt::Std)
BuildRequires:	perl(integer)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::Pod::Coverage)
BuildRequires:	perl(vars)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Filter bogus provides of perl shared objects
%{?perl_default_filter}

%description
Digest::SHA is a complete implementation of the NIST Secure Hash
Standard.  It gives Perl programmers a convenient way to calculate
SHA-1, SHA-224, SHA-256, SHA-384, and SHA-512 message digests.	The
module can handle all types of input, including partial-byte data.

%prep
%setup -q -n Digest-SHA-%{version}

# Fix perl interpreter location for examples
%patch0 -p1

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -type f -name '*.bs' -size 0 -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} \; 2>/dev/null
chmod -R u+w %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes examples/ README
%{_bindir}/shasum
%{_mandir}/man1/shasum.1*
%{_mandir}/man3/Digest::SHA.3pm*
%{perl_vendorarch}/auto/Digest/
%{perl_vendorarch}/Digest/

%changelog
* Wed Feb 29 2012 Paul Howarth <paul@city-fan.org> - 5.71-1
- Update to 5.71
  - Prevented $! from getting clobbered in _bail() routine
  - Added example of BITS mode usage to shasum documentation
- One buildreq per line for readability
- Add buildreqs for Perl core modules that might be dual-lived
- Package examples, patched for perl interpreter location

* Wed Dec 14 2011 Paul Howarth <paul@city-fan.org> - 5.70-1
- Update to 5.70
  - Added BITS mode to addfile method and shasum, which makes partial-byte
    inputs possible via files/STDIN and allows shasum to check all 8074 NIST
    Msg vectors, which previously required special programming

* Tue Nov  8 2011 Paul Howarth <paul@city-fan.org> - 5.63-1
- Update to 5.63
  - Added code to allow very large data inputs all at once (previously limited
    to several hundred MB at a time)
  - Removed outdated reference URLs from several test scripts;these URLs aren't
    essential, and often go stale (CPAN RT#68740)

* Fri Jun 24 2011 Paul Howarth <paul@city-fan.org> - 5.62-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun May 15 2011 Paul Howarth <paul@city-fan.org> - 5.62-1
- Update to 5.62
  - Removed unnecessary loading of MIME::Base64 module

* Wed Mar  9 2011 Paul Howarth <paul@city-fan.org> - 5.61-1
- Update to 5.61
  - Corrected bug in 'algorithm' method
  - Fixed -x option in Makefile.PL
  - Addressed minor documentation oversights

* Thu Mar  3 2011 Paul Howarth <paul@city-fan.org> - 5.60-1
- Update to 5.60
  - Added new SHA-512/224 and SHA-512/256 transforms
  - Simplified shasum by removing duplicative text
  - Improved efficiency of Addfile (expensive -T test now occurs only in
    portable mode)

* Wed Dec 15 2010 Paul Howarth <paul@city-fan.org> - 5.50-1
- Update to 5.50
  - Adopted convention that '-' always means STDIN; actual filename '-'
    accessed as './-' (accords with behaviour of sha1sum/md5sum)
  - Corrected undefined subroutine oversight in shasum
    (inadvertent migration of _bail() from SHA.pm)

* Sun Dec 12 2010 Paul Howarth <paul@city-fan.org> - 5.49-1
- Update to 5.49
  - Modified Addfile to accept all POSIX filenames (standard allows all
    characters except NUL and '/')
  - Updated shasum to more closely mimic sha1sum/md5sum (added "backslash
    processing" to handle newlines and backslashes in filenames)

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 5.48-3
- Rebuild for perl 5.12.1 in Rawhide

* Tue Jun  8 2010 Paul Howarth <paul@city-fan.org> - 5.48-2
- Fix dist tag for RHEL-6 Beta

* Tue Jan  5 2010 Paul Howarth <paul@city-fan.org> - 5.48-1
- Update to 5.48
  - Fixed "shasum -a0" option (CPAN RT#53319)
  - Updated URL for NIST test vectors (files t/nistbit.t, t/nistbyte.t)
- Dist tag for Rawhide no longer needs special-casing

* Sun Sep  6 2009 Paul Howarth <paul@city-fan.org> - 5.47-1
- Import from Fedora
- Update to 5.47 (fixes for 5.10 locations and minor bugfixes)

* Thu Apr 10 2008 Wes Hardaker <wjhns174@hardakers.net> - 5.46-1
- Update to upstream 5.46 for minor bug fixes

* Fri Nov  9 2007 Wes Hardaker <wjhns174@hardakers.net> - 5.45-1
- Update to upstream 5.45
- Change license to match new licensing tags

* Wed Aug 29 2007 Fedora Release Engineering <rel-eng at fedoraproject dot org> - 5.44-6
- Rebuild for selinux ppc32 issue.

* Fri Jun  1 2007 Wes Hardaker <wjhns174@hardakers.net> - 5.44-5
- fix changelog

* Thu May 31 2007 Wes Hardaker <wjhns174@hardakers.net> - 5.44-4
- fix description clause to remove hyphenation
- pass optimization flags to Makefile.PL
- Reverse terms in license to match perl rpm exactly

* Mon May 14 2007  Wes Hardaker <wjhns174@hardakers.net> - 5.44-3
- BuildRequire a slew of modules needed for testing/building

* Tue May  8 2007  Wes Hardaker <wjhns174@hardakers.net> - 5.44-2
- Use vendorarch instead of vendorlib

* Thu Apr 19 2007  Wes Hardaker <wjhns174@hardakers.net> - 5.44-1
- Initial version
